# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::OperationsManagement::Mgmt::V2015_11_01_preview
  module Models
    #
    # Solution properties supported by the OperationsManagement resource
    # provider.
    #
    class SolutionProperties

      include MsRestAzure

      # @return [String] The azure resourceId for the workspace where the
      # solution will be deployed/enabled.
      attr_accessor :workspace_resource_id

      # @return [String] The provisioning state for the solution.
      attr_accessor :provisioning_state

      # @return [Array<String>] The azure resources that will be contained
      # within the solutions. They will be locked and gets deleted
      # automatically when the solution is deleted.
      attr_accessor :contained_resources

      # @return [Array<String>] The resources that will be referenced from this
      # solution. Deleting any of those solution out of band will break the
      # solution.
      attr_accessor :referenced_resources


      #
      # Mapper for SolutionProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SolutionProperties',
          type: {
            name: 'Composite',
            class_name: 'SolutionProperties',
            model_properties: {
              workspace_resource_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'workspaceResourceId',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'provisioningState',
                type: {
                  name: 'String'
                }
              },
              contained_resources: {
                client_side_validation: true,
                required: false,
                serialized_name: 'containedResources',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              referenced_resources: {
                client_side_validation: true,
                required: false,
                serialized_name: 'referencedResources',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
